<html>
<head>
<title>OgreEAGLWindow.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_9e680f2cca56003d76c91ad8153c6d1e.html">GLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_2b7861191a86db021136edf07f6d3897.html">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f6cbbe62e902c93f5f80f28d6caaaaa1.html">EAGL</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreEAGLWindow.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreEAGLWindow_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __EAGLWindow_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __EAGLWindow_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderWindow_8h.html">OgreRenderWindow.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef __OBJC__</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#import &lt;UIKit/UIKit.h&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#import &quot;<a class="code" href="OgreEAGLView_8h.html">OgreEAGLView.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#import &quot;<a class="code" href="OgreEAGLViewController_8h.html">OgreEAGLViewController.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Forward declarations</span>
<a name="l00040"></a>00040 <span class="keyword">@class</span> CAEAGLLayer;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// Define the native window type</span>
<a name="l00043"></a>00043 <span class="keyword">typedef</span> UIWindow *NativeWindowType;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a>00047 <span class="keyword">namespace </span>Ogre {
<a name="l00048"></a>00048     <span class="keyword">class </span>EAGLSupport;
<a name="l00049"></a>00049     <span class="keyword">class </span>EAGLESContext;
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classOgre_1_1EAGLWindow.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1EAGLWindow.html">EAGLWindow</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053         <span class="keyword">protected</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a3a3b3e9440f63414baaa32487913d08c">00054</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#a3a3b3e9440f63414baaa32487913d08c">mClosed</a>;
<a name="l00055"></a><a class="code" href="classOgre_1_1EAGLWindow.html#ad870dfd335b351baf74dcba8ec804ca6">00055</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#ad870dfd335b351baf74dcba8ec804ca6">mVisible</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1EAGLWindow.html#ab02eb2298d5ce1ef47d37e422ca71ccb">00057</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#ab02eb2298d5ce1ef47d37e422ca71ccb" title="Is this using an external window handle?">mIsExternal</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1EAGLWindow.html#aa452aae8874c92d5694af8504f495af3">00059</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#aa452aae8874c92d5694af8504f495af3" title="Is this using an external view handle?">mUsingExternalView</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a1ac6e3d987d0c9f4e40279e3341992d2">00061</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#a1ac6e3d987d0c9f4e40279e3341992d2" title="Is this using an external view controller handle?">mUsingExternalViewController</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063             <span class="comment">// iOS 4 content scaling</span>
<a name="l00064"></a><a class="code" href="classOgre_1_1EAGLWindow.html#ac099c87250647f3f7dc16346c25a5542">00064</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#ac099c87250647f3f7dc16346c25a5542">mIsContentScalingSupported</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1EAGLWindow.html#ae4ef08e6a726518601a18e94bb4d658d">00065</a>             <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1EAGLWindow.html#ae4ef08e6a726518601a18e94bb4d658d">mContentScalingFactor</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a3132eaa54ceda2c17706ef9f93723cb4">00066</a>             <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1EAGLWindow.html#a3132eaa54ceda2c17706ef9f93723cb4">mCurrentOSVersion</a>;
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a113a7d30b89cd830172d2dc3a7d36080">00068</a>             <a class="code" href="classOgre_1_1EAGLSupport.html">EAGLSupport</a>* <a class="code" href="classOgre_1_1EAGLWindow.html#a113a7d30b89cd830172d2dc3a7d36080">mGLSupport</a>;
<a name="l00069"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a0e25543405be42ffceef6b830c97be4f">00069</a>             <a class="code" href="classOgre_1_1EAGLESContext.html">EAGLESContext</a>* <a class="code" href="classOgre_1_1EAGLWindow.html#a0e25543405be42ffceef6b830c97be4f">mContext</a>;
<a name="l00070"></a>00070 <span class="preprocessor">#ifdef __OBJC__</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>            NativeWindowType mWindow;
<a name="l00072"></a>00072             EAGLView *mView;
<a name="l00073"></a>00073             <a class="code" href="interfaceEAGLViewController.html">EAGLViewController</a> *mViewController;
<a name="l00074"></a>00074 <span class="preprocessor">#endif</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>
<a name="l00076"></a><a class="code" href="classOgre_1_1EAGLWindow.html#aa1017378606284c7f15b60a0f046c5fa">00076</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1EAGLWindow.html#aa1017378606284c7f15b60a0f046c5fa">switchFullScreen</a>(<span class="keywordtype">bool</span> fullscreen) { }
<a name="l00077"></a>00077             <span class="keywordtype">void</span> getLeftAndTopFromNativeWindow(<span class="keywordtype">int</span> &amp; left, <span class="keywordtype">int</span> &amp; top, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> width, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> height);
<a name="l00078"></a>00078             <span class="keywordtype">void</span> initNativeCreatedWindow(<span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams);
<a name="l00079"></a>00079             <span class="keywordtype">void</span> createNativeWindow(<span class="keywordtype">int</span> &amp;left, <span class="keywordtype">int</span> &amp;top, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> &amp;width, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> &amp;height, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;title);
<a name="l00080"></a>00080             <span class="keywordtype">void</span> reposition(<span class="keywordtype">int</span> left, <span class="keywordtype">int</span> top);
<a name="l00081"></a>00081             <span class="keywordtype">void</span> resize(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height);
<a name="l00082"></a>00082             <span class="keywordtype">void</span> windowMovedOrResized();
<a name="l00083"></a>00083             <span class="keyword">virtual</span> <span class="keywordtype">void</span> _beginUpdate();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="keyword">public</span>:
<a name="l00086"></a>00086             <a class="code" href="classOgre_1_1EAGLWindow.html">EAGLWindow</a>(<a class="code" href="classOgre_1_1EAGLSupport.html">EAGLSupport</a>* glsupport);
<a name="l00087"></a>00087             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1EAGLWindow.html">EAGLWindow</a>();
<a name="l00088"></a>00088 
<a name="l00089"></a>00089             <span class="keywordtype">void</span> create(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height,
<a name="l00090"></a>00090                         <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092             <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFullscreen(<span class="keywordtype">bool</span> fullscreen, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> width, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> height);
<a name="l00093"></a>00093             <span class="keywordtype">void</span> destroy(<span class="keywordtype">void</span>);
<a name="l00094"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a02818cbc46817900bc980763c199d9eb">00094</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#a02818cbc46817900bc980763c199d9eb" title="Indicates whether the window has been closed by the user.">isClosed</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mClosed; }
<a name="l00095"></a><a class="code" href="classOgre_1_1EAGLWindow.html#af471829bc612500f3d567e0731061d62">00095</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#af471829bc612500f3d567e0731061d62" title="Indicates whether the window is visible (not minimized or obscured)">isVisible</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVisible; }
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a64511c57837fd3d553f8b574cad0520b">00097</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1EAGLWindow.html#a64511c57837fd3d553f8b574cad0520b" title="Set the visibility state.">setVisible</a>(<span class="keywordtype">bool</span> visible) { mVisible = visible; }
<a name="l00098"></a><a class="code" href="classOgre_1_1EAGLWindow.html#a07bec4ae54e6930130eb5581641a4d75">00098</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1EAGLWindow.html#a07bec4ae54e6930130eb5581641a4d75">setClosed</a>(<span class="keywordtype">bool</span> closed) { mClosed = closed; }
<a name="l00099"></a>00099             <span class="keywordtype">void</span> swapBuffers(<span class="keywordtype">bool</span> waitForVSync);
<a name="l00100"></a>00100             <span class="keywordtype">void</span> copyContentsToMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst, FrameBuffer buffer);
<a name="l00101"></a>00101 
<a name="l00111"></a>00111             <span class="keyword">virtual</span> <span class="keywordtype">void</span> getCustomAttribute(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pData);
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classOgre_1_1EAGLWindow.html#add964782e08da2e8d82677a11ab70040">00113</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EAGLWindow.html#add964782e08da2e8d82677a11ab70040">requiresTextureFlipping</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00114"></a>00114     };
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
